import { _WEDA_CLOUD_SDK as WEDA_CLOUD_SDK } from '@cloudbase/weda-client';
interface IBaseState {
    state: {
        [key: string]: any;
    };
    computed: {
        [key: string]: any;
    };
    dataset?: {
        state?: {};
    };
}
declare enum EPLATFORM {
    WEB = "WEB",
    /**
     * 拼写错误
     * 兼容性无法修改
     */
    MINIPROGRAM = "MINIPROGRAME"
}
export declare const subPackageName = "";
export declare let app: IAppAPI;
export declare function registerApp(_app?: IAppAPI): void;
export interface IAppAPI extends IBaseState {
    id: string;
    platform: EPLATFORM;
    __internal__?: {
        getConfig: Function;
    };
    app?: IAppAPI;
    $app?: IAppAPI;
    mainApp?: IAppAPI;
    common: {};
    enumOptions?: {};
    domain: string;
    cloud: typeof WEDA_CLOUD_SDK.CLOUD_SDK;
    /**
     * @deprecated
     */
    dataSources: any;
    utils: {
        formatDate: Function;
        formatEnum: Function;
        get: Function;
        set: Function;
        getCurrentPage: Function;
    };
    /**
     * 内置方法
     */
    _setStateVal: ({ varPath, val }: {
        varPath: any;
        val: any;
    }) => void;
    setState: (state: any) => void;
    /**
     * 微信继承方法
     */
    showLoading?: (param?: any) => void;
    hideLoading?: () => void;
    showToast?: (param: any) => void;
    redirectTo?: (param: any) => void;
}
export declare function removeGlboalApi(): void;
export interface IPageAPI extends IBaseState {
    $page?: IPageAPI;
    handler: {
        [key: string]: any;
    };
    props: {
        [key: string]: any;
    };
    widgets: {
        [key: string]: any;
    };
    setState: (state: any) => void;
    _dataBinds: {
        [key: string]: any;
    };
}
export declare function createPageApi(): IPageAPI;
export {};
