import * as React from 'react';
import { IPageComponent, IComponent } from '@cloudbase/cals';
export default function App({ page, generateComponentsMap, generateActionsMap, generateLowcodeModule, generateWidgetsContext, generateDataBinds, generateComponentSchema, generateContext, onRender, onMounted, injectContext, initDataContext, options, }: {
    page: IComponent | IPageComponent;
    generateLowcodeModule: () => {
        state?: any;
        computed?: {
            [key: string]: Function;
        };
        lifecycle: {
            [key: string]: Function;
        };
        handler: {
            [key: string]: Function;
        };
        renderer: {
            [key: string]: Function;
        };
        style?: {
            code: string;
        }[];
    };
    generateComponentsMap: () => {
        [key: string]: React.FunctionComponent;
    };
    generateActionsMap: () => {
        [key: string]: Function;
    };
    generateWidgetsContext?: (page: any) => any;
    generateDataBinds?: (ctx: any, page: any) => any;
    generateComponentSchema?: (ctx: any, page: any) => any;
    generateContext?: (ctx: any, page: any) => {
        widgetContext: any;
        dataBinds: any;
        componentSchema: any;
    };
    onMounted?: (props: {
        page: any;
        default: Function;
    }) => void;
    onRender?: () => void;
    initDataContext?: any;
    injectContext?: {
        $page?: any;
        dataContext?: any;
        onDataContextChange?: (id: any, data: any) => void;
    };
    options?: {
        looseError?: boolean;
        disabledCheckAuth?: boolean;
    };
}): JSX.Element;
