import { ICodeResource } from '@cloudbase/cals';
import { IEvalCodeModulOptions, LowcodeContext } from './parser/base';
export { generateStyleModule, generateStyleModuleMap } from './parser/lessParser';
export declare const lowcodeContext: LowcodeContext;
/**
 * Reexecute all low code when updated
 */
export declare function generateLowcodeModules({ runtimeWindow, codeModulesMap, onDependencyMiss, dependencies, externals, }: {
    runtimeWindow: Window;
    codeModulesMap: {
        global?: ICodeResource[];
        [pageId: string]: ICodeResource[];
    };
    onDependencyMiss?: () => void;
    dependencies?: object;
    externals?: Record<string, string>;
}): Promise<LowcodeContext>;
export declare function applyLowcode(allModules: any, opts: IEvalCodeModulOptions & {
    onBeforeParse?: Function;
}): Promise<LowcodeContext>;
export declare function cleanLowcodeContext(): void;
