import { IPlatformApp } from '@cloudbase/cals';
/**
 * 简化数据源描述信息数组, 以供低码运行时使用
 * @param datasources 完整的数据源描述信息数组
 */
export declare function getDatasourceProfiles(datasources: any): any;
export declare function getDatasetProfiles(cals: IPlatformApp, apps?: IPlatformApp[], options?: {
    looseError?: boolean;
}): {};
export declare function getConfig(cals: any, options?: {
    deployOptions?: {
        mode: 'production' | 'preview';
    };
    looseError?: boolean;
}): {
    /** 当前是否处于正式发布模式 */
    isProd: boolean;
    /** 低码应用ID */
    appID: any;
    /** 云开发环境ID */
    envID: any;
    /** 应用端ID */
    tcbClientId: any;
    /** 数据源描述对象数组 */
    dataSourceProfiles: any;
    /**
     * 新的dataset变量配置对象
     *  key 为页面ID(全局为$global), val 为变量配置数组
     */
    datasetProfiles: {};
};
